from typing import Tuple

from pjml.abs.component import Component
from pjml.operator.chain import Chain
from pjml.util.distributions import choice


class Select:
    """A permutation is sampled."""

    def __new__(
        cls, *args: Component, seed: int = 0, components: Tuple[Component, ...] = None, **kwargs
    ):
        """Shortcut to create a ConfigSpace."""
        if components is None:
            components = args

        components = (choice(components),)

        return Chain(*components, seed=seed, **kwargs)
