from typing import Tuple

import numpy as np

from pjml.abs.component import Component
from pjml.operator.chain import Chain


class Shuffle:
    """A permutation is sampled."""

    def __new__(
        cls, *args: Component, seed: int = 0, components: Tuple[Component, ...] = None, **kwargs
    ):
        """Shortcut to create a ConfigSpace."""
        if components is None:
            components = args

        lcomps = list(components)
        np.random.shuffle(lcomps)

        return Chain(components=lcomps, seed=seed, **kwargs)
