import json

import math

import zstandard as zs

from pjdata.aux.encoders import digest2pretty

# samples = [os.urandom(30) for _ in range(500)]
samples = [s.encode() for s in """[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 46.70277962456371,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 61.86643910979159,"class_weight": null,"coef0": 40.126381359572875,"decision_function_shape": "ovr","gamma": 50.442764892108094,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 43.67587105856549,"class_weight": "balanced","coef0": 43.89534979741296,"decision_function_shape": "ovo","degree": 8,"gamma": 75.57405052527169,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 43.67587105856549,"class_weight": "balanced","coef0": 43.89534979741296,"decision_function_shape": "ovo","degree": 8,"gamma": 75.57405052527169,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 23.141377215388243,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 23.141377215388243,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 597,"max_features": "auto","min_impurity_decrease": 0.006418127684338671,"min_samples_leaf": 0.1100227355239638,"min_samples_split": 0.23416853974969476,"min_weight_fraction_leaf": 0.27799500522130627,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 597,"max_features": "auto","min_impurity_decrease": 0.006418127684338671,"min_samples_leaf": 0.1100227355239638,"min_samples_split": 0.23416853974969476,"min_weight_fraction_leaf": 0.27799500522130627,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 22.81306054960907,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 22.81306054960907,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 76.05136838301783,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 76.05136838301783,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 981,"max_features": null,"min_impurity_decrease": 0.005573931313545711,"min_samples_leaf": 0.11552227842486734,"min_samples_split": 0.20875165144844948,"min_weight_fraction_leaf": 0.2867322629655995,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 981,"max_features": null,"min_impurity_decrease": 0.005573931313545711,"min_samples_leaf": 0.11552227842486734,"min_samples_split": 0.20875165144844948,"min_weight_fraction_leaf": 0.2867322629655995,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.38233515377156,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.38233515377156,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 2.0495741389091804,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 2.0495741389091804,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 447,"max_features": "sqrt","min_impurity_decrease": 0.014654221745200126,"min_samples_leaf": 0.25830469155892055,"min_samples_split": 0.29181424404884015,"min_weight_fraction_leaf": 0.08785852706611805,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 447,"max_features": "sqrt","min_impurity_decrease": 0.014654221745200126,"min_samples_leaf": 0.25830469155892055,"min_samples_split": 0.29181424404884015,"min_weight_fraction_leaf": 0.08785852706611805,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 35,"max_features": null,"min_impurity_decrease": 0.06974650202905666,"min_samples_leaf": 0.196340811803914,"min_samples_split": 0.2694702671550111,"min_weight_fraction_leaf": 0.11163803450502728,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 35,"max_features": null,"min_impurity_decrease": 0.06974650202905666,"min_samples_leaf": 0.196340811803914,"min_samples_split": 0.2694702671550111,"min_weight_fraction_leaf": 0.11163803450502728,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 13.691640903820204,"class_weight": "balanced","coef0": 38.980702898332545,"decision_function_shape": "ovr","gamma": 75.53655856722169,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 13.691640903820204,"class_weight": "balanced","coef0": 38.980702898332545,"decision_function_shape": "ovr","gamma": 75.53655856722169,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 16.195527630968453,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 16.195527630968453,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.554815910029944,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.554815910029944,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 896,"max_features": null,"min_impurity_decrease": 0.04747941609584974,"min_samples_leaf": 0.0022770796661772297,"min_samples_split": 0.08574453518723309,"min_weight_fraction_leaf": 0.21778231888990832,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 896,"max_features": null,"min_impurity_decrease": 0.04747941609584974,"min_samples_leaf": 0.0022770796661772297,"min_samples_split": 0.08574453518723309,"min_weight_fraction_leaf": 0.21778231888990832,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 426,"max_features": "log2","min_impurity_decrease": 0.12609234326310478,"min_samples_leaf": 0.12616349617299294,"min_samples_split": 0.11677466114338853,"min_weight_fraction_leaf": 0.22088016686778114,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 426,"max_features": "log2","min_impurity_decrease": 0.12609234326310478,"min_samples_leaf": 0.12616349617299294,"min_samples_split": 0.11677466114338853,"min_weight_fraction_leaf": 0.22088016686778114,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 950,"max_features": "log2","min_impurity_decrease": 0.024498183232829797,"min_samples_leaf": 0.22314111032166314,"min_samples_split": 0.06853595577496763,"min_weight_fraction_leaf": 0.26400107917326643,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 950,"max_features": "log2","min_impurity_decrease": 0.024498183232829797,"min_samples_leaf": 0.22314111032166314,"min_samples_split": 0.06853595577496763,"min_weight_fraction_leaf": 0.26400107917326643,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 359,"max_features": null,"min_impurity_decrease": 0.0683604766551941,"min_samples_leaf": 0.1539559762122713,"min_samples_split": 0.06230532340735221,"min_weight_fraction_leaf": 0.18371124621928223,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 359,"max_features": null,"min_impurity_decrease": 0.0683604766551941,"min_samples_leaf": 0.1539559762122713,"min_samples_split": 0.06230532340735221,"min_weight_fraction_leaf": 0.18371124621928223,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 447,"max_features": "log2","min_impurity_decrease": 0.037776895481783736,"min_samples_leaf": 0.01321309312212604,"min_samples_split": 0.19805374106575857,"min_weight_fraction_leaf": 0.0028836424390146884,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 447,"max_features": "log2","min_impurity_decrease": 0.037776895481783736,"min_samples_leaf": 0.01321309312212604,"min_samples_split": 0.19805374106575857,"min_weight_fraction_leaf": 0.0028836424390146884,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 70.07449478797898,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 70.07449478797898,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 430,"max_features": null,"min_impurity_decrease": 0.13039024978399105,"min_samples_leaf": 0.014153205696215213,"min_samples_split": 0.2523424550402493,"min_weight_fraction_leaf": 0.000782784843717077,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 430,"max_features": null,"min_impurity_decrease": 0.13039024978399105,"min_samples_leaf": 0.014153205696215213,"min_samples_split": 0.2523424550402493,"min_weight_fraction_leaf": 0.000782784843717077,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 680,"max_features": "log2","min_impurity_decrease": 0.14351531108326784,"min_samples_leaf": 0.028629865964836628,"min_samples_split": 0.08618774252790812,"min_weight_fraction_leaf": 0.11237509480185677,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 680,"max_features": "log2","min_impurity_decrease": 0.14351531108326784,"min_samples_leaf": 0.028629865964836628,"min_samples_split": 0.08618774252790812,"min_weight_fraction_leaf": 0.11237509480185677,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 638,"max_features": "log2","min_impurity_decrease": 0.11145106052102959,"min_samples_leaf": 0.14760190602649792,"min_samples_split": 0.0739608719885417,"min_weight_fraction_leaf": 0.2909494330087271,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 638,"max_features": "log2","min_impurity_decrease": 0.11145106052102959,"min_samples_leaf": 0.14760190602649792,"min_samples_split": 0.0739608719885417,"min_weight_fraction_leaf": 0.2909494330087271,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.273828021939956,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.273828021939956,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 85.62336059447375,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 85.62336059447375,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 191,"max_features": "sqrt","min_impurity_decrease": 0.19555624174029596,"min_samples_leaf": 0.06910673881115745,"min_samples_split": 0.06400989159265168,"min_weight_fraction_leaf": 0.2267693260258532,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 191,"max_features": "sqrt","min_impurity_decrease": 0.19555624174029596,"min_samples_leaf": 0.06910673881115745,"min_samples_split": 0.06400989159265168,"min_weight_fraction_leaf": 0.2267693260258532,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 18.20429328522415,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 18.20429328522415,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 73.83275435453248,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 73.83275435453248,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 26.95623853932876,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 26.95623853932876,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 143,"max_features": null,"min_impurity_decrease": 0.15550371521354514,"min_samples_leaf": 0.16712162760632138,"min_samples_split": 0.047409239730902886,"min_weight_fraction_leaf": 0.055932936283819255,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 143,"max_features": null,"min_impurity_decrease": 0.15550371521354514,"min_samples_leaf": 0.16712162760632138,"min_samples_split": 0.047409239730902886,"min_weight_fraction_leaf": 0.055932936283819255,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 43.97136610907607,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 43.97136610907607,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 64.05896108150448,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 64.05896108150448,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 582,"max_features": "log2","min_impurity_decrease": 0.10845013707609104,"min_samples_leaf": 0.05907907192012154,"min_samples_split": 0.044601890223793926,"min_weight_fraction_leaf": 0.26450953386550297,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 582,"max_features": "log2","min_impurity_decrease": 0.10845013707609104,"min_samples_leaf": 0.05907907192012154,"min_samples_split": 0.044601890223793926,"min_weight_fraction_leaf": 0.26450953386550297,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 85.12926207567392,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 85.12926207567392,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 64.6463939522674,"class_weight": "balanced","decision_function_shape": "ovr","gamma": 21.726410319050483,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 64.6463939522674,"class_weight": "balanced","decision_function_shape": "ovr","gamma": 21.726410319050483,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 92.8993172563166,"class_weight": "balanced","coef0": 34.01252553907438,"decision_function_shape": "ovo","degree": 7,"gamma": 89.58955827107151,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 92.8993172563166,"class_weight": "balanced","coef0": 34.01252553907438,"decision_function_shape": "ovo","degree": 7,"gamma": 89.58955827107151,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 316,"max_features": "log2","min_impurity_decrease": 0.1688257267632768,"min_samples_leaf": 0.18869984020524613,"min_samples_split": 0.13940013750451616,"min_weight_fraction_leaf": 0.260983135803583,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 316,"max_features": "log2","min_impurity_decrease": 0.1688257267632768,"min_samples_leaf": 0.18869984020524613,"min_samples_split": 0.13940013750451616,"min_weight_fraction_leaf": 0.260983135803583,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 24.750927558970414,"class_weight": null,"decision_function_shape": "ovo","gamma": 78.53334034442777,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 24.750927558970414,"class_weight": null,"decision_function_shape": "ovo","gamma": 78.53334034442777,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 74.71616831980239,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 74.71616831980239,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 141,"max_features": "auto","min_impurity_decrease": 0.17169220934481108,"min_samples_leaf": 0.19234446631526866,"min_samples_split": 0.05852445706609754,"min_weight_fraction_leaf": 0.09015767190978471,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 141,"max_features": "auto","min_impurity_decrease": 0.17169220934481108,"min_samples_leaf": 0.19234446631526866,"min_samples_split": 0.05852445706609754,"min_weight_fraction_leaf": 0.09015767190978471,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 802,"max_features": null,"min_impurity_decrease": 0.1415400307219209,"min_samples_leaf": 0.08401026094296055,"min_samples_split": 0.15963570435181051,"min_weight_fraction_leaf": 0.13187624315897795,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 802,"max_features": null,"min_impurity_decrease": 0.1415400307219209,"min_samples_leaf": 0.08401026094296055,"min_samples_split": 0.15963570435181051,"min_weight_fraction_leaf": 0.13187624315897795,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 94.39960968060362,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 94.39960968060362,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 793,"max_features": "log2","min_impurity_decrease": 0.19973856515443,"min_samples_leaf": 0.0774081459576972,"min_samples_split": 0.2907796086168574,"min_weight_fraction_leaf": 0.09626390923763846,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 793,"max_features": "log2","min_impurity_decrease": 0.19973856515443,"min_samples_leaf": 0.0774081459576972,"min_samples_split": 0.2907796086168574,"min_weight_fraction_leaf": 0.09626390923763846,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 337,"max_features": "sqrt","min_impurity_decrease": 0.14664943756982024,"min_samples_leaf": 0.0364305124981881,"min_samples_split": 0.08684535487929636,"min_weight_fraction_leaf": 0.2839490251697435,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 337,"max_features": "sqrt","min_impurity_decrease": 0.14664943756982024,"min_samples_leaf": 0.0364305124981881,"min_samples_split": 0.08684535487929636,"min_weight_fraction_leaf": 0.2839490251697435,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 348,"max_features": null,"min_impurity_decrease": 0.13928525158379504,"min_samples_leaf": 0.19543295810052932,"min_samples_split": 0.02983038989532997,"min_weight_fraction_leaf": 0.2376981501561491,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 348,"max_features": null,"min_impurity_decrease": 0.13928525158379504,"min_samples_leaf": 0.19543295810052932,"min_samples_split": 0.02983038989532997,"min_weight_fraction_leaf": 0.2376981501561491,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 772,"max_features": "sqrt","min_impurity_decrease": 0.024377645410020077,"min_samples_leaf": 0.08984855220010994,"min_samples_split": 0.25993765107798217,"min_weight_fraction_leaf": 0.07301230827777484,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 772,"max_features": "sqrt","min_impurity_decrease": 0.024377645410020077,"min_samples_leaf": 0.08984855220010994,"min_samples_split": 0.25993765107798217,"min_weight_fraction_leaf": 0.07301230827777484,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.74692658694928,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.74692658694928,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 31.570699713901007,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 79.99937283251906,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 31.570699713901007,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 79.99937283251906,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 16.756836815351637,"class_weight": null,"coef0": 42.03167043406992,"decision_function_shape": "ovr","gamma": 1.9918949264420311,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 16.756836815351637,"class_weight": null,"coef0": 42.03167043406992,"decision_function_shape": "ovr","gamma": 1.9918949264420311,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 730,"max_features": "auto","min_impurity_decrease": 0.12366097575608515,"min_samples_leaf": 0.2512003400392163,"min_samples_split": 0.11780120546035135,"min_weight_fraction_leaf": 0.006663742772586789,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 730,"max_features": "auto","min_impurity_decrease": 0.12366097575608515,"min_samples_leaf": 0.2512003400392163,"min_samples_split": 0.11780120546035135,"min_weight_fraction_leaf": 0.006663742772586789,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 93.68368626581555,"class_weight": null,"coef0": 81.9581074344417,"decision_function_shape": "ovo","degree": 4,"gamma": 50.42121721191082,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 93.68368626581555,"class_weight": null,"coef0": 81.9581074344417,"decision_function_shape": "ovo","degree": 4,"gamma": 50.42121721191082,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 11.225243914977584,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 11.225243914977584,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 833,"max_features": "log2","min_impurity_decrease": 0.14403244812030508,"min_samples_leaf": 0.17438977803770422,"min_samples_split": 0.2575803915896323,"min_weight_fraction_leaf": 0.1585602242760733,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 833,"max_features": "log2","min_impurity_decrease": 0.14403244812030508,"min_samples_leaf": 0.17438977803770422,"min_samples_split": 0.2575803915896323,"min_weight_fraction_leaf": 0.1585602242760733,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.06692625810562,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.06692625810562,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.122092228908485,"class_weight": "balanced","coef0": 31.028471499683608,"decision_function_shape": "ovo","gamma": 16.530351857078024,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.122092228908485,"class_weight": "balanced","coef0": 31.028471499683608,"decision_function_shape": "ovo","gamma": 16.530351857078024,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 874,"max_features": "sqrt","min_impurity_decrease": 0.12163653799338843,"min_samples_leaf": 0.0018891355880309181,"min_samples_split": 0.2394913308241156,"min_weight_fraction_leaf": 0.19117817665223225,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 874,"max_features": "sqrt","min_impurity_decrease": 0.12163653799338843,"min_samples_leaf": 0.0018891355880309181,"min_samples_split": 0.2394913308241156,"min_weight_fraction_leaf": 0.19117817665223225,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 26.899674513185285,"class_weight": null,"coef0": 97.9115246700012,"decision_function_shape": "ovr","gamma": 50.54636944015054,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 26.899674513185285,"class_weight": null,"coef0": 97.9115246700012,"decision_function_shape": "ovr","gamma": 50.54636944015054,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 973,"max_features": "sqrt","min_impurity_decrease": 0.1964701010894959,"min_samples_leaf": 0.14876088193973075,"min_samples_split": 0.043483859175935384,"min_weight_fraction_leaf": 0.1462265088679638,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 973,"max_features": "sqrt","min_impurity_decrease": 0.1964701010894959,"min_samples_leaf": 0.14876088193973075,"min_samples_split": 0.043483859175935384,"min_weight_fraction_leaf": 0.1462265088679638,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 11.395625350576797,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 11.395625350576797,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 780,"max_features": null,"min_impurity_decrease": 0.12926380192031703,"min_samples_leaf": 0.09367550159900104,"min_samples_split": 0.10083917130137138,"min_weight_fraction_leaf": 0.2788616722742351,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 780,"max_features": null,"min_impurity_decrease": 0.12926380192031703,"min_samples_leaf": 0.09367550159900104,"min_samples_split": 0.10083917130137138,"min_weight_fraction_leaf": 0.2788616722742351,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 68.02958663677597,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 68.02958663677597,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 375,"max_features": "sqrt","min_impurity_decrease": 0.005526157761655393,"min_samples_leaf": 0.15928790451612276,"min_samples_split": 0.26175138217950106,"min_weight_fraction_leaf": 0.2215550991437495,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 375,"max_features": "sqrt","min_impurity_decrease": 0.005526157761655393,"min_samples_leaf": 0.15928790451612276,"min_samples_split": 0.26175138217950106,"min_weight_fraction_leaf": 0.2215550991437495,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 19.005380061057828,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 19.005380061057828,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 39.184084319977515,"class_weight": null,"coef0": 76.12833260126378,"decision_function_shape": "ovr","gamma": 4.576776570202644,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 39.184084319977515,"class_weight": null,"coef0": 76.12833260126378,"decision_function_shape": "ovr","gamma": 4.576776570202644,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 659,"max_features": "auto","min_impurity_decrease": 0.06454916566739204,"min_samples_leaf": 0.11051440246606661,"min_samples_split": 0.06815142463956901,"min_weight_fraction_leaf": 0.052333708919827526,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 659,"max_features": "auto","min_impurity_decrease": 0.06454916566739204,"min_samples_leaf": 0.11051440246606661,"min_samples_split": 0.06815142463956901,"min_weight_fraction_leaf": 0.052333708919827526,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 545,"max_features": "log2","min_impurity_decrease": 0.08807368986338737,"min_samples_leaf": 0.1006129091507768,"min_samples_split": 0.23683610546446576,"min_weight_fraction_leaf": 0.029162297221847933,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 545,"max_features": "log2","min_impurity_decrease": 0.08807368986338737,"min_samples_leaf": 0.1006129091507768,"min_samples_split": 0.23683610546446576,"min_weight_fraction_leaf": 0.029162297221847933,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 910,"max_features": "auto","min_impurity_decrease": 0.030148653529074254,"min_samples_leaf": 0.034676146859779246,"min_samples_split": 0.1074414134928847,"min_weight_fraction_leaf": 0.24031974538694395,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 910,"max_features": "auto","min_impurity_decrease": 0.030148653529074254,"min_samples_leaf": 0.034676146859779246,"min_samples_split": 0.1074414134928847,"min_weight_fraction_leaf": 0.24031974538694395,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 41.148258357942964,"class_weight": null,"decision_function_shape": "ovr","gamma": 72.03394491937289,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 41.148258357942964,"class_weight": null,"decision_function_shape": "ovr","gamma": 72.03394491937289,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 403,"max_features": "log2","min_impurity_decrease": 0.05643397978585947,"min_samples_leaf": 0.08503051068460939,"min_samples_split": 0.2721341209985518,"min_weight_fraction_leaf": 0.011084379274296707,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 403,"max_features": "log2","min_impurity_decrease": 0.05643397978585947,"min_samples_leaf": 0.08503051068460939,"min_samples_split": 0.2721341209985518,"min_weight_fraction_leaf": 0.011084379274296707,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 350,"max_features": "log2","min_impurity_decrease": 0.024997632241399437,"min_samples_leaf": 0.25127877291863643,"min_samples_split": 0.09613445166782926,"min_weight_fraction_leaf": 0.16348665850801564,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 350,"max_features": "log2","min_impurity_decrease": 0.024997632241399437,"min_samples_leaf": 0.25127877291863643,"min_samples_split": 0.09613445166782926,"min_weight_fraction_leaf": 0.16348665850801564,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 821,"max_features": "log2","min_impurity_decrease": 0.11035505084912477,"min_samples_leaf": 0.2525688431232636,"min_samples_split": 0.21436639807157643,"min_weight_fraction_leaf": 0.04600504509606131,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 821,"max_features": "log2","min_impurity_decrease": 0.11035505084912477,"min_samples_leaf": 0.2525688431232636,"min_samples_split": 0.21436639807157643,"min_weight_fraction_leaf": 0.04600504509606131,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 97.82443838959448,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 97.82443838959448,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.66352471972793,"class_weight": null,"coef0": 98.77622487487899,"decision_function_shape": "ovo","degree": 6,"gamma": 35.564441249954925,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.66352471972793,"class_weight": null,"coef0": 98.77622487487899,"decision_function_shape": "ovo","degree": 6,"gamma": 35.564441249954925,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 38.544712592983565,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 38.544712592983565,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 28.264672697991614,"class_weight": null,"decision_function_shape": "ovr","gamma": 74.23209967022883,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 28.264672697991614,"class_weight": null,"decision_function_shape": "ovr","gamma": 74.23209967022883,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 11.31069500737388,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 11.31069500737388,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 35.56287002175708,"class_weight": "balanced","coef0": 84.80826516612176,"decision_function_shape": "ovr","gamma": 72.51113630138168,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 35.56287002175708,"class_weight": "balanced","coef0": 84.80826516612176,"decision_function_shape": "ovr","gamma": 72.51113630138168,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 394,"max_features": null,"min_impurity_decrease": 0.04079698045341951,"min_samples_leaf": 0.08731123037685505,"min_samples_split": 0.005909755990475498,"min_weight_fraction_leaf": 0.1538193661424979,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 394,"max_features": null,"min_impurity_decrease": 0.04079698045341951,"min_samples_leaf": 0.08731123037685505,"min_samples_split": 0.005909755990475498,"min_weight_fraction_leaf": 0.1538193661424979,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 27.74842759091576,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 4.359856955325217,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 27.74842759091576,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 4.359856955325217,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 59.26191806584171,"class_weight": "balanced","coef0": 81.44133961648919,"decision_function_shape": "ovr","gamma": 40.84233925019523,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 59.26191806584171,"class_weight": "balanced","coef0": 81.44133961648919,"decision_function_shape": "ovr","gamma": 40.84233925019523,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 11.37805180490556,"class_weight": "balanced","coef0": 39.13322745233895,"decision_function_shape": "ovr","gamma": 22.70020171438486,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 11.37805180490556,"class_weight": "balanced","coef0": 39.13322745233895,"decision_function_shape": "ovr","gamma": 22.70020171438486,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 84.97923038022533,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 84.97923038022533,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 13.028202898422537,"class_weight": null,"decision_function_shape": "ovo","gamma": 84.88689325075937,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 13.028202898422537,"class_weight": null,"decision_function_shape": "ovo","gamma": 84.88689325075937,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 54.79055067718837,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 54.79055067718837,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 311,"max_features": null,"min_impurity_decrease": 0.111863508598209,"min_samples_leaf": 0.07041385550326154,"min_samples_split": 0.17343924838544522,"min_weight_fraction_leaf": 0.25004365646491605,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 311,"max_features": null,"min_impurity_decrease": 0.111863508598209,"min_samples_leaf": 0.07041385550326154,"min_samples_split": 0.17343924838544522,"min_weight_fraction_leaf": 0.25004365646491605,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 578,"max_features": null,"min_impurity_decrease": 0.08138157928738576,"min_samples_leaf": 0.027333624689704808,"min_samples_split": 0.023636016773979546,"min_weight_fraction_leaf": 0.18900414230361537,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 578,"max_features": null,"min_impurity_decrease": 0.08138157928738576,"min_samples_leaf": 0.027333624689704808,"min_samples_split": 0.023636016773979546,"min_weight_fraction_leaf": 0.18900414230361537,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 361,"max_features": "sqrt","min_impurity_decrease": 0.17497221627328388,"min_samples_leaf": 0.2858903770060716,"min_samples_split": 0.06896288121681807,"min_weight_fraction_leaf": 0.18236793170441665,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 361,"max_features": "sqrt","min_impurity_decrease": 0.17497221627328388,"min_samples_leaf": 0.2858903770060716,"min_samples_split": 0.06896288121681807,"min_weight_fraction_leaf": 0.18236793170441665,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 289,"max_features": "log2","min_impurity_decrease": 0.1962901621976216,"min_samples_leaf": 0.1302719290796451,"min_samples_split": 0.16658875646359605,"min_weight_fraction_leaf": 0.0672857476705345,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 289,"max_features": "log2","min_impurity_decrease": 0.1962901621976216,"min_samples_leaf": 0.1302719290796451,"min_samples_split": 0.16658875646359605,"min_weight_fraction_leaf": 0.0672857476705345,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 30.884938753424382,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 30.884938753424382,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 19.836633898539695,"class_weight": "balanced","coef0": 5.3158742432493415,"decision_function_shape": "ovo","gamma": 56.57198337800029,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 19.836633898539695,"class_weight": "balanced","coef0": 5.3158742432493415,"decision_function_shape": "ovo","gamma": 56.57198337800029,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 39.373307694251395,"class_weight": null,"decision_function_shape": "ovr","gamma": 31.74502631272797,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 39.373307694251395,"class_weight": null,"decision_function_shape": "ovr","gamma": 31.74502631272797,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 74.46095346887003,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 74.46095346887003,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 41.31720227749371,"class_weight": "balanced","coef0": 92.5378108815171,"decision_function_shape": "ovr","gamma": 28.45310977549663,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 41.31720227749371,"class_weight": "balanced","coef0": 92.5378108815171,"decision_function_shape": "ovr","gamma": 28.45310977549663,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 78.12692718180236,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 78.12692718180236,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.268592314640976,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.268592314640976,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 91.24215753902057,"class_weight": null,"decision_function_shape": "ovo","gamma": 69.1933419237084,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 91.24215753902057,"class_weight": null,"decision_function_shape": "ovo","gamma": 69.1933419237084,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 465,"max_features": "log2","min_impurity_decrease": 0.05031400802031767,"min_samples_leaf": 0.1324589664305944,"min_samples_split": 0.20531547933178995,"min_weight_fraction_leaf": 0.05201341402588566,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 465,"max_features": "log2","min_impurity_decrease": 0.05031400802031767,"min_samples_leaf": 0.1324589664305944,"min_samples_split": 0.20531547933178995,"min_weight_fraction_leaf": 0.05201341402588566,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 15.733427827577758,"class_weight": "balanced","coef0": 56.443763758476386,"decision_function_shape": "ovo","gamma": 23.011047265997952,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 15.733427827577758,"class_weight": "balanced","coef0": 56.443763758476386,"decision_function_shape": "ovo","gamma": 23.011047265997952,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 596,"max_features": "sqrt","min_impurity_decrease": 0.11725944742317018,"min_samples_leaf": 0.0012551151181123307,"min_samples_split": 0.13515913232732693,"min_weight_fraction_leaf": 0.2653984338728566,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 596,"max_features": "sqrt","min_impurity_decrease": 0.11725944742317018,"min_samples_leaf": 0.0012551151181123307,"min_samples_split": 0.13515913232732693,"min_weight_fraction_leaf": 0.2653984338728566,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 51.552962139846706,"class_weight": null,"coef0": 41.25513852473161,"decision_function_shape": "ovr","gamma": 78.72704911311163,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 51.552962139846706,"class_weight": null,"coef0": 41.25513852473161,"decision_function_shape": "ovr","gamma": 78.72704911311163,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 44.57229660983366,"class_weight": "balanced","coef0": 99.1296621839241,"decision_function_shape": "ovo","degree": 2,"gamma": 88.54535270893234,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 44.57229660983366,"class_weight": "balanced","coef0": 99.1296621839241,"decision_function_shape": "ovo","degree": 2,"gamma": 88.54535270893234,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 303,"max_features": "auto","min_impurity_decrease": 0.07799391160337638,"min_samples_leaf": 0.19353126827832065,"min_samples_split": 0.2140476803923825,"min_weight_fraction_leaf": 0.013299031060155142,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 303,"max_features": "auto","min_impurity_decrease": 0.07799391160337638,"min_samples_leaf": 0.19353126827832065,"min_samples_split": 0.2140476803923825,"min_weight_fraction_leaf": 0.013299031060155142,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 63.59441424165815,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 63.59441424165815,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 39.456964521380186,"class_weight": "balanced","coef0": 79.88290708198083,"decision_function_shape": "ovr","degree": 2,"gamma": 42.93071374450199,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 39.456964521380186,"class_weight": "balanced","coef0": 79.88290708198083,"decision_function_shape": "ovr","degree": 2,"gamma": 42.93071374450199,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 22.043754051291504,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 22.043754051291504,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 90.09309819171354,"class_weight": "balanced","coef0": 11.275432080104398,"decision_function_shape": "ovo","degree": 0,"gamma": 31.112979395213433,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 90.09309819171354,"class_weight": "balanced","coef0": 11.275432080104398,"decision_function_shape": "ovo","degree": 0,"gamma": 31.112979395213433,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 787,"max_features": "log2","min_impurity_decrease": 0.1664536227964858,"min_samples_leaf": 0.034939653321492486,"min_samples_split": 0.11462358382433152,"min_weight_fraction_leaf": 0.09285897478470367,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 787,"max_features": "log2","min_impurity_decrease": 0.1664536227964858,"min_samples_leaf": 0.034939653321492486,"min_samples_split": 0.11462358382433152,"min_weight_fraction_leaf": 0.09285897478470367,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 604,"max_features": "auto","min_impurity_decrease": 0.11549923296215969,"min_samples_leaf": 0.19570138464174816,"min_samples_split": 0.03273714043523729,"min_weight_fraction_leaf": 0.045148784929624604,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 604,"max_features": "auto","min_impurity_decrease": 0.11549923296215969,"min_samples_leaf": 0.19570138464174816,"min_samples_split": 0.03273714043523729,"min_weight_fraction_leaf": 0.045148784929624604,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 54.76699751213176,"class_weight": "balanced","coef0": 29.074370210308786,"decision_function_shape": "ovo","gamma": 58.958604829129406,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 54.76699751213176,"class_weight": "balanced","coef0": 29.074370210308786,"decision_function_shape": "ovo","gamma": 58.958604829129406,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 237,"max_features": "sqrt","min_impurity_decrease": 0.19704303365922082,"min_samples_leaf": 0.12385773114318553,"min_samples_split": 0.17167770944883348,"min_weight_fraction_leaf": 0.06738897022097162,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 237,"max_features": "sqrt","min_impurity_decrease": 0.19704303365922082,"min_samples_leaf": 0.12385773114318553,"min_samples_split": 0.17167770944883348,"min_weight_fraction_leaf": 0.06738897022097162,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 17.575057177567775,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 3.892149907759382,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 17.575057177567775,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 3.892149907759382,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 91.50416899138548,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 91.50416899138548,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 17,"max_features": "sqrt","min_impurity_decrease": 0.09406387709662067,"min_samples_leaf": 0.22685419025237524,"min_samples_split": 0.0878636486930702,"min_weight_fraction_leaf": 0.1077197279376725,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 17,"max_features": "sqrt","min_impurity_decrease": 0.09406387709662067,"min_samples_leaf": 0.22685419025237524,"min_samples_split": 0.0878636486930702,"min_weight_fraction_leaf": 0.1077197279376725,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 983,"max_features": "log2","min_impurity_decrease": 0.07490306806302953,"min_samples_leaf": 0.26419955959452157,"min_samples_split": 0.08811210453390993,"min_weight_fraction_leaf": 0.13897559363451828,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 983,"max_features": "log2","min_impurity_decrease": 0.07490306806302953,"min_samples_leaf": 0.26419955959452157,"min_samples_split": 0.08811210453390993,"min_weight_fraction_leaf": 0.13897559363451828,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 273,"max_features": "log2","min_impurity_decrease": 0.1877176462412151,"min_samples_leaf": 0.08059348108776918,"min_samples_split": 0.08187400942140387,"min_weight_fraction_leaf": 0.27876465819650387,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 273,"max_features": "log2","min_impurity_decrease": 0.1877176462412151,"min_samples_leaf": 0.08059348108776918,"min_samples_split": 0.08187400942140387,"min_weight_fraction_leaf": 0.27876465819650387,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 529,"max_features": null,"min_impurity_decrease": 0.14962155324994228,"min_samples_leaf": 0.2403397314008781,"min_samples_split": 0.23156783068532408,"min_weight_fraction_leaf": 0.18745186644080958,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 529,"max_features": null,"min_impurity_decrease": 0.14962155324994228,"min_samples_leaf": 0.2403397314008781,"min_samples_split": 0.23156783068532408,"min_weight_fraction_leaf": 0.18745186644080958,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 236,"max_features": "log2","min_impurity_decrease": 0.013826170936269921,"min_samples_leaf": 0.19303846082748347,"min_samples_split": 0.2896217651924071,"min_weight_fraction_leaf": 0.2516614168847453,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 236,"max_features": "log2","min_impurity_decrease": 0.013826170936269921,"min_samples_leaf": 0.19303846082748347,"min_samples_split": 0.2896217651924071,"min_weight_fraction_leaf": 0.2516614168847453,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 69.72482418444723,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 69.72482418444723,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 900,"max_features": "auto","min_impurity_decrease": 0.10202726969296663,"min_samples_leaf": 0.021660897827893374,"min_samples_split": 0.13468559606541305,"min_weight_fraction_leaf": 0.2719489964209534,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 900,"max_features": "auto","min_impurity_decrease": 0.10202726969296663,"min_samples_leaf": 0.021660897827893374,"min_samples_split": 0.13468559606541305,"min_weight_fraction_leaf": 0.2719489964209534,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 89.38857413587812,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 89.38857413587812,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 558,"max_features": null,"min_impurity_decrease": 0.10636120135547106,"min_samples_leaf": 0.1512611836148032,"min_samples_split": 0.2927026004217853,"min_weight_fraction_leaf": 0.2896320389762978,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 558,"max_features": null,"min_impurity_decrease": 0.10636120135547106,"min_samples_leaf": 0.1512611836148032,"min_samples_split": 0.2927026004217853,"min_weight_fraction_leaf": 0.2896320389762978,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 97.24491230202968,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 97.24491230202968,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 237,"max_features": "auto","min_impurity_decrease": 0.19625944092565073,"min_samples_leaf": 0.22696462590841737,"min_samples_split": 0.05342343950737468,"min_weight_fraction_leaf": 0.03285296550333178,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 237,"max_features": "auto","min_impurity_decrease": 0.19625944092565073,"min_samples_leaf": 0.22696462590841737,"min_samples_split": 0.05342343950737468,"min_weight_fraction_leaf": 0.03285296550333178,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 78.15903912369356,"class_weight": null,"coef0": 17.136839340292276,"decision_function_shape": "ovo","degree": 5,"gamma": 24.066955166550898,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 78.15903912369356,"class_weight": null,"coef0": 17.136839340292276,"decision_function_shape": "ovo","degree": 5,"gamma": 24.066955166550898,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 6.656948134601388,"class_weight": "balanced","coef0": 73.39362557554516,"decision_function_shape": "ovr","gamma": 59.68317630826962,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 6.656948134601388,"class_weight": "balanced","coef0": 73.39362557554516,"decision_function_shape": "ovr","gamma": 59.68317630826962,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 884,"max_features": "sqrt","min_impurity_decrease": 0.002186064514063557,"min_samples_leaf": 0.11221127939077483,"min_samples_split": 0.17653576948511285,"min_weight_fraction_leaf": 0.2802932699085344,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 884,"max_features": "sqrt","min_impurity_decrease": 0.002186064514063557,"min_samples_leaf": 0.11221127939077483,"min_samples_split": 0.17653576948511285,"min_weight_fraction_leaf": 0.2802932699085344,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 60.40729998733265,"class_weight": "balanced","coef0": 33.96104991408729,"decision_function_shape": "ovo","gamma": 7.027251653217607,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 60.40729998733265,"class_weight": "balanced","coef0": 33.96104991408729,"decision_function_shape": "ovo","gamma": 7.027251653217607,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 298,"max_features": null,"min_impurity_decrease": 0.07834152602047095,"min_samples_leaf": 0.1571287541295809,"min_samples_split": 0.2559662628177658,"min_weight_fraction_leaf": 0.23809505724845073,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 298,"max_features": null,"min_impurity_decrease": 0.07834152602047095,"min_samples_leaf": 0.1571287541295809,"min_samples_split": 0.2559662628177658,"min_weight_fraction_leaf": 0.23809505724845073,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 26.07877403199695,"class_weight": null,"coef0": 45.818888726703676,"decision_function_shape": "ovr","gamma": 74.02635929677962,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 26.07877403199695,"class_weight": null,"coef0": 45.818888726703676,"decision_function_shape": "ovr","gamma": 74.02635929677962,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 71.0415201480341,"class_weight": "balanced","decision_function_shape": "ovr","gamma": 80.10146592727368,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 71.0415201480341,"class_weight": "balanced","decision_function_shape": "ovr","gamma": 80.10146592727368,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 361,"max_features": null,"min_impurity_decrease": 0.1785523726596261,"min_samples_leaf": 0.11187066618007278,"min_samples_split": 0.030127204047300588,"min_weight_fraction_leaf": 0.032089925328692356,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 361,"max_features": null,"min_impurity_decrease": 0.1785523726596261,"min_samples_leaf": 0.11187066618007278,"min_samples_split": 0.030127204047300588,"min_weight_fraction_leaf": 0.032089925328692356,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 12.337075607383346,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 12.337075607383346,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 50.97262416616949,"class_weight": "balanced","coef0": 56.855466400941346,"decision_function_shape": "ovr","gamma": 68.79164728120827,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 50.97262416616949,"class_weight": "balanced","coef0": 56.855466400941346,"decision_function_shape": "ovr","gamma": 68.79164728120827,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 84.08216729287376,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 84.08216729287376,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 739,"max_features": "log2","min_impurity_decrease": 0.15301268208009194,"min_samples_leaf": 0.013891974196582153,"min_samples_split": 0.2771922624478284,"min_weight_fraction_leaf": 0.1194550078935529,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 739,"max_features": "log2","min_impurity_decrease": 0.15301268208009194,"min_samples_leaf": 0.013891974196582153,"min_samples_split": 0.2771922624478284,"min_weight_fraction_leaf": 0.1194550078935529,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 67.2714966712777,"class_weight": "balanced","decision_function_shape": "ovr","gamma": 66.59270249367404,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 67.2714966712777,"class_weight": "balanced","decision_function_shape": "ovr","gamma": 66.59270249367404,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 445,"max_features": "auto","min_impurity_decrease": 0.03420077259260044,"min_samples_leaf": 0.177566006939377,"min_samples_split": 0.008385698823968328,"min_weight_fraction_leaf": 0.2399018265596662,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 445,"max_features": "auto","min_impurity_decrease": 0.03420077259260044,"min_samples_leaf": 0.177566006939377,"min_samples_split": 0.008385698823968328,"min_weight_fraction_leaf": 0.2399018265596662,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 47.15465064236186,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 47.15465064236186,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 89.25231795089479,"class_weight": "balanced","coef0": 72.37014632503107,"decision_function_shape": "ovo","degree": 6,"gamma": 76.55674356445085,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 89.25231795089479,"class_weight": "balanced","coef0": 72.37014632503107,"decision_function_shape": "ovo","degree": 6,"gamma": 76.55674356445085,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 4.567492735583333,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 86.73481905208452,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 4.567492735583333,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 86.73481905208452,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 63.59245430560317,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 63.59245430560317,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 29,"max_features": "log2","min_impurity_decrease": 0.04996186545732471,"min_samples_leaf": 0.13415488704985265,"min_samples_split": 0.2511014143593723,"min_weight_fraction_leaf": 0.24230722905640587,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 29,"max_features": "log2","min_impurity_decrease": 0.04996186545732471,"min_samples_leaf": 0.13415488704985265,"min_samples_split": 0.2511014143593723,"min_weight_fraction_leaf": 0.24230722905640587,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 248,"max_features": "log2","min_impurity_decrease": 0.01658618047239353,"min_samples_leaf": 0.11836308164183282,"min_samples_split": 0.10282695605054297,"min_weight_fraction_leaf": 0.04171189818407439,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 248,"max_features": "log2","min_impurity_decrease": 0.01658618047239353,"min_samples_leaf": 0.11836308164183282,"min_samples_split": 0.10282695605054297,"min_weight_fraction_leaf": 0.04171189818407439,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 82.83714914565492,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 71.38511099592138,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 82.83714914565492,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 71.38511099592138,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 8.034093387900237,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 8.034093387900237,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 79.7210144111842,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 79.7210144111842,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 507,"max_features": "auto","min_impurity_decrease": 0.15651920204171466,"min_samples_leaf": 0.1659205794801144,"min_samples_split": 0.23004693352642636,"min_weight_fraction_leaf": 0.17418531912385127,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 507,"max_features": "auto","min_impurity_decrease": 0.15651920204171466,"min_samples_leaf": 0.1659205794801144,"min_samples_split": 0.23004693352642636,"min_weight_fraction_leaf": 0.17418531912385127,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 483,"max_features": null,"min_impurity_decrease": 0.16080346900489031,"min_samples_leaf": 0.25648481588076194,"min_samples_split": 0.10517292467806849,"min_weight_fraction_leaf": 0.10512533581079661,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 483,"max_features": null,"min_impurity_decrease": 0.16080346900489031,"min_samples_leaf": 0.25648481588076194,"min_samples_split": 0.10517292467806849,"min_weight_fraction_leaf": 0.10512533581079661,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 231,"max_features": "sqrt","min_impurity_decrease": 0.07354063690071437,"min_samples_leaf": 0.2590457984298383,"min_samples_split": 0.06269265894026753,"min_weight_fraction_leaf": 0.041428105528618094,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 231,"max_features": "sqrt","min_impurity_decrease": 0.07354063690071437,"min_samples_leaf": 0.2590457984298383,"min_samples_split": 0.06269265894026753,"min_weight_fraction_leaf": 0.041428105528618094,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 21.55539389533865,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 21.55539389533865,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 400,"max_features": "sqrt","min_impurity_decrease": 0.03778681058435316,"min_samples_leaf": 0.22483359330204605,"min_samples_split": 0.2759868714682733,"min_weight_fraction_leaf": 0.1038285957826834,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 400,"max_features": "sqrt","min_impurity_decrease": 0.03778681058435316,"min_samples_leaf": 0.22483359330204605,"min_samples_split": 0.2759868714682733,"min_weight_fraction_leaf": 0.1038285957826834,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 6.513677807830645,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 49.59732044304035,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 6.513677807830645,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 49.59732044304035,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 911,"max_features": "sqrt","min_impurity_decrease": 0.18852168680045597,"min_samples_leaf": 0.14586227031490798,"min_samples_split": 0.003605510347926374,"min_weight_fraction_leaf": 0.1587186392424814,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 911,"max_features": "sqrt","min_impurity_decrease": 0.18852168680045597,"min_samples_leaf": 0.14586227031490798,"min_samples_split": 0.003605510347926374,"min_weight_fraction_leaf": 0.1587186392424814,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 68.55694493568156,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 68.55694493568156,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 73.1823972655273,"class_weight": "balanced","coef0": 92.25741549354134,"decision_function_shape": "ovr","gamma": 15.731259533434462,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 73.1823972655273,"class_weight": "balanced","coef0": 92.25741549354134,"decision_function_shape": "ovr","gamma": 15.731259533434462,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 37.12395049771927,"class_weight": null,"coef0": 72.77357469812308,"decision_function_shape": "ovo","degree": 0,"gamma": 54.62294283221955,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 37.12395049771927,"class_weight": null,"coef0": 72.77357469812308,"decision_function_shape": "ovo","degree": 0,"gamma": 54.62294283221955,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 355,"max_features": "auto","min_impurity_decrease": 0.016645721484564734,"min_samples_leaf": 0.208664784242112,"min_samples_split": 0.2754160207849541,"min_weight_fraction_leaf": 0.11983732627999928,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 355,"max_features": "auto","min_impurity_decrease": 0.016645721484564734,"min_samples_leaf": 0.208664784242112,"min_samples_split": 0.2754160207849541,"min_weight_fraction_leaf": 0.11983732627999928,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 856,"max_features": "sqrt","min_impurity_decrease": 0.19574162887864058,"min_samples_leaf": 0.24873771019785176,"min_samples_split": 0.25058093857886055,"min_weight_fraction_leaf": 0.1637355192261375,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 856,"max_features": "sqrt","min_impurity_decrease": 0.19574162887864058,"min_samples_leaf": 0.24873771019785176,"min_samples_split": 0.25058093857886055,"min_weight_fraction_leaf": 0.1637355192261375,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 86.94483685439964,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 86.94483685439964,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 87.33920145424791,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 87.33920145424791,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 93.1526265028981,"class_weight": "balanced","coef0": 38.337010968581794,"decision_function_shape": "ovo","degree": 0,"gamma": 60.758059607732335,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 93.1526265028981,"class_weight": "balanced","coef0": 38.337010968581794,"decision_function_shape": "ovo","degree": 0,"gamma": 60.758059607732335,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 962,"max_features": null,"min_impurity_decrease": 0.187067531588199,"min_samples_leaf": 0.11801364448612871,"min_samples_split": 0.29769577103497014,"min_weight_fraction_leaf": 0.13006463818180694,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 962,"max_features": null,"min_impurity_decrease": 0.187067531588199,"min_samples_leaf": 0.11801364448612871,"min_samples_split": 0.29769577103497014,"min_weight_fraction_leaf": 0.13006463818180694,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 46.42639853040272,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 46.42639853040272,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 57.887150623769195,"class_weight": "balanced","coef0": 96.98465734450743,"decision_function_shape": "ovo","degree": 10,"gamma": 21.95332382045105,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 57.887150623769195,"class_weight": "balanced","coef0": 96.98465734450743,"decision_function_shape": "ovo","degree": 10,"gamma": 21.95332382045105,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 51.817180669444724,"class_weight": "balanced","coef0": 43.07460233128639,"decision_function_shape": "ovo","degree": 1,"gamma": 98.35468559410634,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 51.817180669444724,"class_weight": "balanced","coef0": 43.07460233128639,"decision_function_shape": "ovo","degree": 1,"gamma": 98.35468559410634,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 260,"max_features": "sqrt","min_impurity_decrease": 0.16670605599608337,"min_samples_leaf": 0.2892722996166784,"min_samples_split": 0.21909317702560027,"min_weight_fraction_leaf": 0.1562590635586567,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 260,"max_features": "sqrt","min_impurity_decrease": 0.16670605599608337,"min_samples_leaf": 0.2892722996166784,"min_samples_split": 0.21909317702560027,"min_weight_fraction_leaf": 0.1562590635586567,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 555,"max_features": "log2","min_impurity_decrease": 0.04365664995020549,"min_samples_leaf": 0.18507392717267948,"min_samples_split": 0.21759909831086258,"min_weight_fraction_leaf": 0.2598645280833951,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 555,"max_features": "log2","min_impurity_decrease": 0.04365664995020549,"min_samples_leaf": 0.18507392717267948,"min_samples_split": 0.21759909831086258,"min_weight_fraction_leaf": 0.2598645280833951,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 71.8915501889965,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 71.8915501889965,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 168,"max_features": "sqrt","min_impurity_decrease": 0.18332769430796436,"min_samples_leaf": 0.17416120561181966,"min_samples_split": 0.06752925047955108,"min_weight_fraction_leaf": 0.030547960753104883,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 168,"max_features": "sqrt","min_impurity_decrease": 0.18332769430796436,"min_samples_leaf": 0.17416120561181966,"min_samples_split": 0.06752925047955108,"min_weight_fraction_leaf": 0.030547960753104883,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 693,"max_features": "sqrt","min_impurity_decrease": 0.15379970553831446,"min_samples_leaf": 0.09446803064640305,"min_samples_split": 0.029348370090637586,"min_weight_fraction_leaf": 0.010798546664844888,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 693,"max_features": "sqrt","min_impurity_decrease": 0.15379970553831446,"min_samples_leaf": 0.09446803064640305,"min_samples_split": 0.029348370090637586,"min_weight_fraction_leaf": 0.010798546664844888,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 18.5566815611543,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 18.5566815611543,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 31,"max_features": null,"min_impurity_decrease": 0.18778241796545925,"min_samples_leaf": 0.1092352126958431,"min_samples_split": 0.246834703311315,"min_weight_fraction_leaf": 0.2821904017394832,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 31,"max_features": null,"min_impurity_decrease": 0.18778241796545925,"min_samples_leaf": 0.1092352126958431,"min_samples_split": 0.246834703311315,"min_weight_fraction_leaf": 0.2821904017394832,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 182,"max_features": "auto","min_impurity_decrease": 0.11600948801805132,"min_samples_leaf": 0.25672703161194327,"min_samples_split": 0.22509665590221048,"min_weight_fraction_leaf": 0.1831889302913236,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 182,"max_features": "auto","min_impurity_decrease": 0.11600948801805132,"min_samples_leaf": 0.25672703161194327,"min_samples_split": 0.22509665590221048,"min_weight_fraction_leaf": 0.1831889302913236,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 654,"max_features": "sqrt","min_impurity_decrease": 0.007396089789471239,"min_samples_leaf": 0.00029240954612504843,"min_samples_split": 0.28768004929057,"min_weight_fraction_leaf": 0.09724275801311437,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 654,"max_features": "sqrt","min_impurity_decrease": 0.007396089789471239,"min_samples_leaf": 0.00029240954612504843,"min_samples_split": 0.28768004929057,"min_weight_fraction_leaf": 0.09724275801311437,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 95.52870032390118,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 95.52870032390118,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 79.79295872883404,"class_weight": null,"coef0": 87.51702825122959,"decision_function_shape": "ovr","degree": 8,"gamma": 31.79626111169867,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 79.79295872883404,"class_weight": null,"coef0": 87.51702825122959,"decision_function_shape": "ovr","degree": 8,"gamma": 31.79626111169867,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 638,"max_features": "log2","min_impurity_decrease": 0.194116129639963,"min_samples_leaf": 0.22193250669276138,"min_samples_split": 0.25288632718737963,"min_weight_fraction_leaf": 0.032532299895556116,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 638,"max_features": "log2","min_impurity_decrease": 0.194116129639963,"min_samples_leaf": 0.22193250669276138,"min_samples_split": 0.25288632718737963,"min_weight_fraction_leaf": 0.032532299895556116,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.27121338447408,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 34.27121338447408,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 829,"max_features": "auto","min_impurity_decrease": 0.10750068946269922,"min_samples_leaf": 0.11172317329869923,"min_samples_split": 0.06063323177508336,"min_weight_fraction_leaf": 0.2655123945493832,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 829,"max_features": "auto","min_impurity_decrease": 0.10750068946269922,"min_samples_leaf": 0.11172317329869923,"min_samples_split": 0.06063323177508336,"min_weight_fraction_leaf": 0.2655123945493832,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 84.58618689322994,"class_weight": "balanced","coef0": 25.240310731032444,"decision_function_shape": "ovo","degree": 4,"gamma": 96.32948508454956,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 84.58618689322994,"class_weight": "balanced","coef0": 25.240310731032444,"decision_function_shape": "ovo","degree": 4,"gamma": 96.32948508454956,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 241,"max_features": "log2","min_impurity_decrease": 0.016057059329985114,"min_samples_leaf": 0.10295385907303256,"min_samples_split": 0.05076010154189315,"min_weight_fraction_leaf": 0.08771240757968025,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 241,"max_features": "log2","min_impurity_decrease": 0.016057059329985114,"min_samples_leaf": 0.10295385907303256,"min_samples_split": 0.05076010154189315,"min_weight_fraction_leaf": 0.08771240757968025,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.62142107319224,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.62142107319224,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 20.95681362551369,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 20.95681362551369,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 13.331682205413806,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 13.331682205413806,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 40.53811520027045,"class_weight": null,"coef0": 21.944052937403878,"decision_function_shape": "ovo","gamma": 8.114300533909985,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 40.53811520027045,"class_weight": null,"coef0": 21.944052937403878,"decision_function_shape": "ovo","gamma": 8.114300533909985,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 737,"max_features": "sqrt","min_impurity_decrease": 0.09472808667370924,"min_samples_leaf": 0.02444599210877388,"min_samples_split": 0.17542827050648424,"min_weight_fraction_leaf": 0.2835185030944368,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 737,"max_features": "sqrt","min_impurity_decrease": 0.09472808667370924,"min_samples_leaf": 0.02444599210877388,"min_samples_split": 0.17542827050648424,"min_weight_fraction_leaf": 0.2835185030944368,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 36.46735587704558,"class_weight": null,"decision_function_shape": "ovr","gamma": 88.40839801382054,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 36.46735587704558,"class_weight": null,"decision_function_shape": "ovr","gamma": 88.40839801382054,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 47.18063099545199,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 47.18063099545199,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 95.93369333008441,"class_weight": null,"coef0": 1.2497884517970292,"decision_function_shape": "ovr","gamma": 74.35002991386962,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 95.93369333008441,"class_weight": null,"coef0": 1.2497884517970292,"decision_function_shape": "ovr","gamma": 74.35002991386962,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 94.84276538186478,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 94.84276538186478,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 474,"max_features": "auto","min_impurity_decrease": 0.12311237004356845,"min_samples_leaf": 0.08617903564815711,"min_samples_split": 0.2972898484833985,"min_weight_fraction_leaf": 0.08807913604255527,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 474,"max_features": "auto","min_impurity_decrease": 0.12311237004356845,"min_samples_leaf": 0.08617903564815711,"min_samples_split": 0.2972898484833985,"min_weight_fraction_leaf": 0.08807913604255527,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 21.981319419110413,"class_weight": "balanced","decision_function_shape": "ovr","gamma": 19.868625422565128,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 21.981319419110413,"class_weight": "balanced","decision_function_shape": "ovr","gamma": 19.868625422565128,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 57.88472076631613,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 57.88472076631613,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 819,"max_features": "log2","min_impurity_decrease": 0.05914269454217167,"min_samples_leaf": 0.02367199040987068,"min_samples_split": 0.05599552131039252,"min_weight_fraction_leaf": 0.12273133201748704,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 819,"max_features": "log2","min_impurity_decrease": 0.05914269454217167,"min_samples_leaf": 0.02367199040987068,"min_samples_split": 0.05599552131039252,"min_weight_fraction_leaf": 0.12273133201748704,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 102,"max_features": null,"min_impurity_decrease": 0.08061809854053137,"min_samples_leaf": 0.25577311359766663,"min_samples_split": 0.10204748125291693,"min_weight_fraction_leaf": 0.002265888666593663,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 102,"max_features": null,"min_impurity_decrease": 0.08061809854053137,"min_samples_leaf": 0.25577311359766663,"min_samples_split": 0.10204748125291693,"min_weight_fraction_leaf": 0.002265888666593663,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 457,"max_features": "sqrt","min_impurity_decrease": 0.04578259765015711,"min_samples_leaf": 0.07496389432488307,"min_samples_split": 0.25379703092043576,"min_weight_fraction_leaf": 0.001652469426675296,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 457,"max_features": "sqrt","min_impurity_decrease": 0.04578259765015711,"min_samples_leaf": 0.07496389432488307,"min_samples_split": 0.25379703092043576,"min_weight_fraction_leaf": 0.001652469426675296,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 60.68083801308023,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 60.68083801308023,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-05}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 285,"max_features": "log2","min_impurity_decrease": 0.11122689613423338,"min_samples_leaf": 0.12122913106897373,"min_samples_split": 0.05424841546761839,"min_weight_fraction_leaf": 0.07699054800366242,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 285,"max_features": "log2","min_impurity_decrease": 0.11122689613423338,"min_samples_leaf": 0.12122913106897373,"min_samples_split": 0.05424841546761839,"min_weight_fraction_leaf": 0.07699054800366242,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.01158531137587,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 32.01158531137587,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.01}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 83.75261875440296,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 83.75261875440296,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 691,"max_features": "auto","min_impurity_decrease": 0.05979031498016818,"min_samples_leaf": 0.21526424529795643,"min_samples_split": 0.24105148654780317,"min_weight_fraction_leaf": 0.17216361941935887,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 691,"max_features": "auto","min_impurity_decrease": 0.05979031498016818,"min_samples_leaf": 0.21526424529795643,"min_samples_split": 0.24105148654780317,"min_weight_fraction_leaf": 0.17216361941935887,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 877,"max_features": null,"min_impurity_decrease": 0.015004426495808444,"min_samples_leaf": 0.14722006918618408,"min_samples_split": 0.13144153569970385,"min_weight_fraction_leaf": 0.01022468131723706,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "gini","max_depth": 877,"max_features": null,"min_impurity_decrease": 0.015004426495808444,"min_samples_leaf": 0.14722006918618408,"min_samples_split": 0.13144153569970385,"min_weight_fraction_leaf": 0.01022468131723706,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 58.29285421814117,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 84.80486148996079,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 58.29285421814117,"class_weight": "balanced","decision_function_shape": "ovo","gamma": 84.80486148996079,"kernel": "rbf","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 94.86636017169467,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 94.86636017169467,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 979,"max_features": null,"min_impurity_decrease": 0.1765804655997449,"min_samples_leaf": 0.029368213199234522,"min_samples_split": 0.2697020585488283,"min_weight_fraction_leaf": 0.06612438571680573,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 979,"max_features": null,"min_impurity_decrease": 0.1765804655997449,"min_samples_leaf": 0.029368213199234522,"min_samples_split": 0.2697020585488283,"min_weight_fraction_leaf": 0.06612438571680573,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 103,"max_features": null,"min_impurity_decrease": 0.18841440968362072,"min_samples_leaf": 0.08830907464750642,"min_samples_split": 0.25950645603239747,"min_weight_fraction_leaf": 0.04243969926013471,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 103,"max_features": null,"min_impurity_decrease": 0.18841440968362072,"min_samples_leaf": 0.08830907464750642,"min_samples_split": 0.25950645603239747,"min_weight_fraction_leaf": 0.04243969926013471,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 4.536501993952985,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 4.536501993952985,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 61.02863211772457,"class_weight": null,"coef0": 51.32378698951656,"decision_function_shape": "ovo","degree": 2,"gamma": 90.24983090325973,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 61.02863211772457,"class_weight": null,"coef0": 51.32378698951656,"decision_function_shape": "ovo","degree": 2,"gamma": 90.24983090325973,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 9.141988554256258,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 9.141988554256258,"class_weight": null,"decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 0.0001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 755,"max_features": "sqrt","min_impurity_decrease": 0.07581997263350376,"min_samples_leaf": 0.04839285985867825,"min_samples_split": 0.14169390017333638,"min_weight_fraction_leaf": 0.15552036386624388,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 755,"max_features": "sqrt","min_impurity_decrease": 0.07581997263350376,"min_samples_leaf": 0.04839285985867825,"min_samples_split": 0.14169390017333638,"min_weight_fraction_leaf": 0.15552036386624388,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 87,"max_features": "log2","min_impurity_decrease": 0.1345958676633889,"min_samples_leaf": 0.09632649640058465,"min_samples_split": 0.05251396185775836,"min_weight_fraction_leaf": 0.019313002422531866,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 87,"max_features": "log2","min_impurity_decrease": 0.1345958676633889,"min_samples_leaf": 0.09632649640058465,"min_samples_split": 0.05251396185775836,"min_weight_fraction_leaf": 0.019313002422531866,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 19.011356500151138,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 19.011356500151138,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 831,"max_features": "auto","min_impurity_decrease": 0.08551151520310148,"min_samples_leaf": 0.20313029080937697,"min_samples_split": 0.1452926542541912,"min_weight_fraction_leaf": 0.1547551850960249,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 831,"max_features": "auto","min_impurity_decrease": 0.08551151520310148,"min_samples_leaf": 0.20313029080937697,"min_samples_split": 0.1452926542541912,"min_weight_fraction_leaf": 0.1547551850960249,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 54.90429268533457,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 54.90429268533457,"class_weight": "balanced","decision_function_shape": "ovo","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 1.4233832480124933,"class_weight": null,"coef0": 51.48402387338516,"decision_function_shape": "ovr","gamma": 99.39676730300447,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 1.4233832480124933,"class_weight": null,"coef0": 51.48402387338516,"decision_function_shape": "ovr","gamma": 99.39676730300447,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 10000}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 408,"max_features": "sqrt","min_impurity_decrease": 0.012216901980433148,"min_samples_leaf": 0.2575172907141183,"min_samples_split": 0.2926558322801416,"min_weight_fraction_leaf": 0.2602984066308529,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 408,"max_features": "sqrt","min_impurity_decrease": 0.012216901980433148,"min_samples_leaf": 0.2575172907141183,"min_samples_split": 0.2926558322801416,"min_weight_fraction_leaf": 0.2602984066308529,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 806,"max_features": "sqrt","min_impurity_decrease": 0.04533601409789356,"min_samples_leaf": 0.10719763931485903,"min_samples_split": 0.15223603180355408,"min_weight_fraction_leaf": 0.04274750504688148,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": null,"criterion": "entropy","max_depth": 806,"max_features": "sqrt","min_impurity_decrease": 0.04533601409789356,"min_samples_leaf": 0.10719763931485903,"min_samples_split": 0.15223603180355408,"min_weight_fraction_leaf": 0.04274750504688148,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 63.298176474571775,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 63.298176474571775,"class_weight": "balanced","decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.001}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not minority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "gaussian"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "NB@pjml.tool.data.modeling.supervised.classifier.nb","config": {"distribution": "bernoulli"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 100,"max_features": "log2","min_impurity_decrease": 0.05003227308509715,"min_samples_leaf": 0.22733774714970156,"min_samples_split": 0.24348820240300426,"min_weight_fraction_leaf": 0.048477158179782875,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "gini","max_depth": 100,"max_features": "log2","min_impurity_decrease": 0.05003227308509715,"min_samples_leaf": 0.22733774714970156,"min_samples_split": 0.24348820240300426,"min_weight_fraction_leaf": 0.048477158179782875,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 30.876945884278907,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 30.876945884278907,"class_weight": null,"decision_function_shape": "ovr","kernel": "linear","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": false,"tol": 1e-06}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 80.10571382065876,"class_weight": null,"coef0": 47.12052055779898,"decision_function_shape": "ovr","degree": 1,"gamma": 72.53040761742972,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 80.10571382065876,"class_weight": null,"coef0": 47.12052055779898,"decision_function_shape": "ovr","degree": 1,"gamma": 72.53040761742972,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 48.13247998096652,"class_weight": "balanced","coef0": 83.25045423639303,"decision_function_shape": "ovr","degree": 3,"gamma": 19.101835223753564,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not minority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 48.13247998096652,"class_weight": "balanced","coef0": 83.25045423639303,"decision_function_shape": "ovr","degree": 3,"gamma": 19.101835223753564,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 0.1}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 80.1663409047063,"class_weight": null,"coef0": 16.331107195221428,"decision_function_shape": "ovr","degree": 7,"gamma": 3.2833425653274393,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "OverS@pjml.tool.data.processing.instance.sampler.over.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 80.1663409047063,"class_weight": null,"coef0": 16.331107195221428,"decision_function_shape": "ovr","degree": 7,"gamma": 3.2833425653274393,"kernel": "poly","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 100}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "OFÆdñOéNnWÅV08âDîgê","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 997,"max_features": "sqrt","min_impurity_decrease": 0.053075693882466204,"min_samples_leaf": 0.14239129722820532,"min_samples_split": 0.11415354942829893,"min_weight_fraction_leaf": 0.035220196207520246,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
[{"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "u"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "all","seed": 0}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "scale"}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "DT@pjml.tool.data.modeling.supervised.classifier.dt","config": {"class_weight": "balanced","criterion": "entropy","max_depth": 997,"max_features": "sqrt","min_impurity_decrease": 0.053075693882466204,"min_samples_leaf": 0.14239129722820532,"min_samples_split": 0.11415354942829893,"min_weight_fraction_leaf": 0.035220196207520246,"seed": 0,"splitter": "best"}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "u"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "u"}]
[{"_id": "File@pjml.tool.data.flow.file","config": {"description": "No description.","matrices_hash": "","name": "iris.arff","path": "./"},"step": "u"}, {"_id": "Partition@pjml.tool.collection.expand.partition","config": {"fields": ["X","Y"],"partitions": 10,"seed": 0,"split_type": "cv"},"step": "a"}, {"_id": "Map@pjml.tool.collection.transform.map","config": {"transformers": [{"_id": "Wrap@pjml.meta.wrap","config": {"transformers": [{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "translate"}},{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [-1,1]}}]}},{"_id": "Chain@pjml.tool.chain","config": {"transformers": [{"_id": "MinMax@pjml.tool.data.processing.feature.scaler.minmax","config": {"feature_range": [0,1]}},{"_id": "Std@pjml.tool.data.processing.feature.scaler.std","config": {"operation": "full"}},{"_id": "UnderS@pjml.tool.data.processing.instance.sampler.under.random","config": {"sampling_strategy": "not majority","seed": 0}}]}},{"_id": "ApplyUsing@pjml.tool.data.flow.applyusing","config": {"transformers": [{"_id": "SVMC@pjml.tool.data.modeling.supervised.classifier.svmc","config": {"C": 61.86643910979159,"class_weight": null,"coef0": 40.126381359572875,"decision_function_shape": "ovr","gamma": 50.442764892108094,"kernel": "sigmoid","max_iter": 1000000,"probability": false,"seed": 0,"shrinking": true,"tol": 10}}]}}]}},{"_id": "Metric@pjml.tool.data.evaluation.metric","config": {"functions": ["accuracy"],"prediction": "Z","target": "Y"}}]},"step": "a"}, {"_id": "Summ@pjml.tool.collection.reduce.summ","config": {"field": "R","function": "mean_std"},"step": "a"}]
""".split('\n')]
train = samples[30:]
test = samples[:30]
size = 999999999
did = zs.train_dictionary(
    dict_size=size, samples=train, threads=-1
)
print('dict:', len(did.as_bytes()))
cctx = zs.ZstdCompressor(threads=-1, dict_data=did, write_dict_id=False)
dd = zs.ZstdDecompressor(dict_data=did)

cctx0 = zs.ZstdCompressor(threads=-1)
dd0 = zs.ZstdDecompressor()

ts = [
]

acc = {'orig': 0, 'comp': 0, 'comp w/ dic': 0, '%comp': 0, '%comp w/ dic': 0}
for t in test:
    c0 = cctx0.compress(t)
    c = cctx.compress(t)

    d0 = dd.decompress(c0)
    d = dd.decompress(c)
    print(
        len(t), len(c0), len(c), ' ',
        'compressed:', f'{round(100 * len(c0) / len(t)) }%', ' ',
        'compressed with dic:', f'{round(100 * len(c) / len(t)) }%'
    )
    acc['orig'] += round(len(t) / len(test))
    acc['comp'] += round(len(c0) / len(test))
    acc['comp w/ dic'] += round(len(c) / len(test))
    acc['%comp'] += round((100 * len(c0) / len(t))) / len(test)
    acc['%comp w/ dic'] += round(100 * len(c) / len(t)) / len(test)

    # print('prettyfied:', len(digest2pretty(c)))
print(json.dumps(acc, indent=4))
# TODO: round numbers in config to reduce total size when converted to string
